%if 0%{?el7}
%define dist .el7
%endif

%{!?_unitdir: %global _unitdir /usr/lib/systemd/system}
%{!?_tmpfilesdir:%global _tmpfilesdir %{_usr}/lib/tmpfiles.d}

Name:           mpd
Version:        0.19.13
Release:        1%{?dist}
Summary:        Music Player Daemon (MPD)

Packager:       momo-i <webmaster@momo-i.org>
Vendor:         momo-i, http://www.momo-i.org/

Group:          Applications/Multimedia
License:        GPLv2
URL:            http://www.musicpd.org/
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

Patch0:         mpd-0.19.2-wildmidi.patch
Patch1:         mpd-0.19.13-make.patch

Source0:		http://www.musicpd.org/download/mpd/stable/%{name}-%{version}.tar.xz
Source1:		mpd-tmpfiles.conf
Source2:        mpd.conf
Source3:        mpd.init
Source4:        mpd.logrotate

Obsoletes:      %{name}-doc <= 0.18.14

Requires:       wildmidi
Requires(pre):  shadow-utils

%if 0%{?fedora} >= 21 || 0%{?rhel} >= 7
BuildRequires:	glib2-devel >= 2.28
BuildRequires:	systemd-devel
%endif

BuildRequires:	tcp_wrappers-devel
BuildRequires:	yajl-devel
BuildRequires:	libshout-devel
BuildRequires:	libid3tag-devel
BuildRequires:	sqlite-devel
BuildRequires:	libsamplerate-devel
BuildRequires:	curl-devel
BuildRequires:	libsoup-devel
BuildRequires:	libcdio-devel
%if 0%{?fedora} >= 21 || 0%{?rhel} >= 7
BuildRequires:	libcdio-paranoia-devel
BuildRequires:	audiofile-devel
%endif
BuildRequires:	bzip2-devel
BuildRequires:	zziplib-devel
BuildRequires:	flac-devel
BuildRequires:	libsndfile-devel
BuildRequires:	wavpack-devel
BuildRequires:	jack-audio-connection-kit-devel
BuildRequires:	libao-devel
BuildRequires:	pulseaudio-libs-devel
BuildRequires:	doxygen xmlto
BuildRequires:	avahi-glib-devel

%if 0%{?fedora}
BuildRequires:	libmodplug-devel
BuildRequires:	wildmidi-devel
BuildRequires:	game-music-emu-devel
BuildRequires:	libffado-devel
BuildRequires:  fluidsynth-devel
BuildRequires:  openal-soft-devel
%endif

### new packages since rel 13
BuildRequires:  libmikmod-devel
BuildRequires:  genisoimage
BuildRequires:  valgrind-devel

### Custom rpms
BuildRequires:	faad2-devel
#BuildRequires:	faac-devel
BuildRequires:	ffmpeg-devel
BuildRequires:	libmad
BuildRequires:	mpg123-devel
BuildRequires:	lame-devel
#if 0%%{?fedora} == 20
#BuildRequires:	sidplay-libs-devel
#endif
BuildRequires:	twolame-devel
BuildRequires:  libmms-devel
BuildRequires:  libmpdclient-devel
BuildRequires:  libicu-devel
#BuildRequires:	libmpcdec-devel
#BuildRequires:  musepack-devel

%if 0%{?fedora}
BuildRequires:	roaraudio-devel
%endif

# since 0.19.x
%if 0%{?fedora} || 0%{?rhel} >= 7
BuildRequires:	boost-devel
%endif
BuildRequires:	expat-devel
BuildRequires:	libsmbclient-devel
BuildRequires:	libnfs-devel
BuildRequires:	libupnp-devel
%if 0%{?fedora}
BuildRequires:	adplug-devel
BuildRequires:	soxr-devel
%endif
BuildRequires:	libmp4v2-devel
BuildRequires:	shine-devel
BuildRequires:  opus-devel
BuildRequires:  avahi-devel

%description
A daemon for playing music of various formats.  Music is played through the
server's audio device.  The daemon stores info about all available music,
and this info can be easily searched and retrieved.  Player control, info
retrieval, and playlist management can all be managed remotely.

%prep
%setup -q

%patch0 -p1
%patch1 -p1

%if 0%{?fedora} >= 21 || 0%{?rhel} >= 7
./autogen.sh
%endif

%if 0%{?fedora} >= 21 || 0%{?rhel} >= 7
RESTART="/usr/bin/systemctl restart mpd.service > /dev/null 2>/dev/null || true"
%else
RESTART="/sbin/service mpd restart > /dev/null 2>/dev/null || true"
%endif

sed -e "s,@RESTART@,$RESTART,g" < %{SOURCE4} > mpd.logrotate

%build
%configure \
	--enable-database \
	--enable-libmpdclient \
	--enable-expat \
	--enable-upnp \
%if 0%{?fedora}
	--enable-adplug \
	--enable-soxr \
%endif
	--enable-alsa \
	--enable-ao \
	--enable-smbclient \
	--enable-nfs \
%if 0%{?fedora} >= 21
	--enable-audiofile \
%endif
	--enable-zlib \
	--enable-bzip2 \
	--enable-cdio-paranoia \
	--enable-curl \
	--enable-soup \
	--enable-documentation \
	--enable-dsd \
	--enable-flac \
	--enable-httpd-output \
	--enable-id3 \
	--enable-iso9660 \
	--enable-jack \
	--enable-lastfm \
	--enable-soundcloud \
	--enable-lame-encoder \
	--enable-libwrap \
	--enable-lsr \
	--enable-mad \
	--enable-mikmod \
	--enable-mp4v2 \
	--enable-mvp \
	--enable-pipe-output \
	--enable-pulse \
	--enable-recorder-output \
	--enable-mms \
	--enable-shine-encoder \
%if 0%{?fedora} || 0%{?rhel} >= 6
	--enable-shout \
%endif
	--enable-sndfile \
	--enable-sqlite \
%if 0%{?fedora} >= 21 || 0%{?rhel} >= 7
	--enable-systemd-daemon \
	--with-systemdsystemunitdir=%{_unitdir} \
%endif
	--enable-twolame-encoder \
	--enable-vorbis \
	--enable-vorbis-encoder \
	--enable-wave-encoder \
	--enable-wavpack \
%if 0%{?fedora}
	--enable-modplug \
	--enable-openal \
	--enable-wildmidi \
	--enable-gme \
	--enable-roar \
	--enable-ffado \
	--enable-fluidsynth \
%endif
%if 0%{?rhel} < 7
	--with-boost=no \
%endif
	--enable-ffmpeg \
	--enable-zzip \
	--enable-icu \
	--enable-glib \
	--enable-neighbor-plugins \
	--enable-mpg123

#if 0%{?fedora} == 20
#	--enable-sidplay \
#endif

### libmad test
%{__cp} %{_includedir}/mad.h .
make %{?_smp_mflags}

%install
rm -rf $RPM_BUILD_ROOT
install -d -m755 $RPM_BUILD_ROOT%{_bindir}
install -d -m755 $RPM_BUILD_ROOT%{_sysconfdir}
install -d -m755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
%if 0%{?fedora} >= 21 || 0%{?rhel} >= 7
install -d -m755 $RPM_BUILD_ROOT%{_unitdir}
install -D -m644 systemd/mpd.service $RPM_BUILD_ROOT%{_unitdir}/mpd.service
install -D -m644 systemd/mpd.socket $RPM_BUILD_ROOT%{_unitdir}/mpd.socket
install -D -m644 %{SOURCE1} $RPM_BUILD_ROOT%{_tmpfilesdir}/mpd.conf
%else
install -d -m0755 $RPM_BUILD_ROOT%{_sysconfdir}/rc.d/init.d
install -D -m0755 %{SOURCE3} $RPM_BUILD_ROOT%{_sysconfdir}/rc.d/init.d/mpd
%endif
install -d -m755 $RPM_BUILD_ROOT%{_mandir}/man{1,5}
install -d -m755 $RPM_BUILD_ROOT%{_localstatedir}/log/%{name}
install -d -m755 $RPM_BUILD_ROOT%{_localstatedir}/lib/%{name}
install -d -m755 $RPM_BUILD_ROOT%{_localstatedir}/run/mpd

install -D -m755 src/mpd $RPM_BUILD_ROOT%{_bindir}/mpd
install -D -m644 doc/mpd.1 $RPM_BUILD_ROOT%{_mandir}/man1/mpd.1
install -D -m644 doc/mpd.conf.5 $RPM_BUILD_ROOT%{_mandir}/man5/mpd.conf.5
touch $RPM_BUILD_ROOT%{_localstatedir}/lib/mpd/mpd.state

install -d -m777 $RPM_BUILD_ROOT%{_localstatedir}/run/mpd

### mpd.conf
install -D -m644 %{SOURCE2} $RPM_BUILD_ROOT%{_sysconfdir}/mpd.conf

### logrotate
install -D -m644 mpd.logrotate $RPM_BUILD_ROOT%{_sysconfdir}/logrotate.d/mpd

%clean
rm -rf $RPM_BUILD_ROOT

%pre
getent group mpd > /dev/null || groupadd -r mpd
getent passwd mpd > /dev/null || \
	useradd -r -g mpd -d %{_localstatedir}/lib/mpd -s /sbin/nologin \
	-c "Music Player Daemon System" mpd
:

%post
%if 0%{?fedora} >= 21 || 0%{?rhel} >= 7
%systemd_post mpd.service
%else
/sbin/chkconfig --add mpd
%endif

%preun
%if 0%{?fedora} >= 21 || 0%{?rhel} >= 7
%systemd_preun mpd.service
%else
if [ $1 -eq 0 ]; then
	/sbin/service mpd stop > /dev/null 2>&1
	/sbin/chkconfig --del mpd
fi
%endif

%postun
%if 0%{?fedora} >= 21 || 0%{?rhel} >= 7
%systemd_postun_with_restart mpd.service
%endif

%files
%defattr(-,root,root,-)
%doc AUTHORS INSTALL NEWS README
%doc doc/*.xml doc/mpdconf.example
%{!?_licensedir:%global license %%doc}
%license COPYING
%{_bindir}/mpd
%attr(0755,mpd,mpd) %config(noreplace) %{_sysconfdir}/mpd.conf
%if 0%{?fedora} >= 21 || 0%{?rhel} >= 7
%{_tmpfilesdir}/mpd.conf
%{_unitdir}/mpd.service
%{_unitdir}/mpd.socket
%else
%{_sysconfdir}/rc.d/init.d/mpd
%endif
%{_mandir}/man1/mpd.1*
%{_mandir}/man5/mpd.conf.5*
%attr(0755,mpd,mpd) %dir %{_localstatedir}/log/%{name}
%attr(0755,mpd,mpd) %dir %{_localstatedir}/lib/%{name}
%attr(-,mpd,mpd) %{_localstatedir}/lib/%{name}/mpd.state
%{_sysconfdir}/logrotate.d/mpd

%changelog
* Sun Mar 06 2016 momo-i <webmaster@momo-i.org> - 0.19.13-1
- Update to 0.19.13

* Sat Mar 05 2016 momo-i <webmaster@momo-i.org> - 0.19.12-3
- Drop faac

* Wed Feb 17 2016 momo-i <webmaster@momo-i.org> - 0.19.12-2
- Rebuilt for ffmpeg

* Mon Dec 21 2015 momo-i <webmaster@momo-i.org> - 0.19.12-1
- Update to 0.19.12

* Sun Nov 08 2015 momo-i <webmaster@momo-i.org> - 0.19.11-1
- Update to 0.19.11
- Drop systemd patch

* Mon Oct 05 2015 momo-i <webmaster@momo-i.org> - 0.19.10-8
- Drop el5 support

* Wed Sep 16 2015 momo-i <webmaster@momo-i.org> - 0.19.10-7
- Rebuitl for libnfs

* Thu Sep 03 2015 momo-i <webmaster@momo-i.org> - 0.19.10-6
- Update dist for centos7

* Mon Aug 10 2015 momo-i <webmaster@momo-i.org> - 0.19.10-5
- Rebuilt for fc23

* Tue Jul 28 2015 momo-i <webmaster@momo-i.org> - 0.19.10-4
- Rebuilt for x264

* Mon Jun 22 2015 momo-i <webmaster@momo-i.org> - 0.19.10-3
- Update to 0.19.10

* Fri Apr 17 2015 momo-i <webmaster@momo-i.org> - 0.19.9-3
- Rebuilt for fc22

* Mon Mar  9 2015 momo-i <webmaster@momo-i.org> - 0.19.9-2
- Update to 0.19.9

* Fri Jan 16 2015 momo-i <webmaster@momo-i.org> - 0.19.8-2
- Update to 0.19.8

* Sat Dec 13 2014 momo-i <webmaster@momo-i.org> - 0.19.6-2
- Update to 0.19.6
- change systemd for fedora 21

* Thu Nov 13 2014 momo-i <webmaster@momo-i.org> - 0.19.3-2
- Update to 0.19.3

* Wed Nov 12 2014 momo-i <webmaster@momo-i.org> - 0.19.2-2
- Rebuilt for el7

* Tue Nov 11 2014 momo-i <webmaster@momo-i.org> - 0.19.2-1
- Update to 0.19.2
- Add encoder package

* Wed Sep 17 2014 momo-i <webmaster@momo-i.org> - 0.18.14-14
- Update to 0.18.14

* Mon Jun  9 2014 momo-i <webmaster@momo-i.org> - 0.18.11-13
- Update to 0.18.11

* Wed Mar 26 2014 momo-i <webmaster@momo-i.org> - 0.18.9-13
- Add new related packages

* Mon Mar 24 2014 momo-i <webmaster@momo-i.org> - 0.18.9-12
- Update to 0.18.9

* Mon Feb 10 2014 momo-i <webmaster@momo-i.org> - 0.18.8-12
- Update to 0.18.8

* Fri Jan 24 2014 momo-i <webmaster@momo-i.org> - 0.18.7-12
- Update for x264

* Fri Jan 17 2014 momo-i <webmaster@momo-i.org> - 0.18.7-11
- Fixed wildmidi configuration path

* Fri Jan 17 2014 momo-i <webmaster@momo-i.org> - 0.18.7-10
- Add logrotate

* Tue Jan 14 2014 momo-i <webmaster@momo-i.org> - 0.18.7-9
- Update to 0.18.7

* Fri Jan 10 2014 momo-i <webmaster@momo-i.org> - 0.18.6-9
- Update to 0.18.6

* Wed Nov 27 2013 momo-i <webmaster@momo-i.org> - 0.18.5-8
- Update to 0.18.5

* Wed Jul 17 2013 momo-i <webmaster@momo-i.org> 0.17.4-8
- For ffmpeg 2.0

* Mon Jul  8 2013 momo-i <webmaster@momo-i.org> 0.17.4-7
- Delete sidplay on fedora19...

* Mon Jul  8 2013 momo-i <webmaster@momo-i.org> 0.17.4-6
- Update for fedora19

* Thu Jun 27 2013 momo-i <webmaster@momo-i.org> 0.17.4-4
- Update tmpfiles.d/mpd.conf
- Create /var/lib/mpd... /var/log/mpd...

* Wed Jun 26 2013 momo-i <webmaster@momo-i.org> 0.17.4-1
- Initial rpm release.
